Subject: Re: bug#15983: 24.3; Emacs Not Killing Child Process

From: Joan Karadimov <[email-masked]>
Date: Sun, 22 Dec 2013 04:03:12 +0200

>
> > I am aware that 'taskkill' is not present on windowses (is that a word?)
> > older than XP. This makes it no worse than 'CreateToolhelp32Snapshot'.
>
> No, the toolhelp functions are available on Windows 2000 and even on
> Windows 98.  They are unavailable only on NT 4.0.
>
MSDN states that the "Minimum supported client" is XP. I guess 2000 is
counted with the server ones and 9x is not even considered.

> > > This might be "good enough" -- we err on the safe side, and only leave
> > > some subprocesses not killed in rare situations.  Does this strategy
> > > solve the problem which started this bug report?
>
> You didn't answer that question, but I assume the answer is YES.
>
It should fix the problem, yes. And it should be safe

> I think it would be better to also require that process-start-time is
> before the time kill-process-tree is called.  This might miss some
> children, if they happen to be spawned right after the call, but it is
> safer.
>
This should already be reflected in the requirement that all processes that
are killed were already in the initial-process-tree (the first snapshot).
But there is no harm in being more explicit about it in the code.

Also, didn't you mean ">" in the above inequality?  A child process
> cannot be born before its parent, right?  Or am I missing something?
>
Yes, of course. You are not missing anything.

> The only thing that we should worry about is not to accidentally kill
> unrelated processes.  Everything else is no worse than what we have
> now.
>
I'll start working on some code that I can show, then.